// Created by: X
// Web: http://www.createdbyx.com/
// Date: July 9, 2008
// =============================================

using System;
using System.Text;
using System.Xml;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using System.IO;
using System.Collections.Generic;
using XMLDocContentReader.Properties;

// TODO: replace this with the type you want to read.
using TRead = System.Xml.XmlDocument;

namespace XMLDocContentReader
{
    /// <summary>
    /// This class will be instantiated by the XNA Content Pipeline
    /// to read the specified data type from binary .xnb format.
    /// 
    /// Unlike the other Content Pipeline support classes, this should
    /// be a part of your main game project, and not the Content Pipeline
    /// Extension Library project.
    /// </summary>
    public class XMLDocContentReader : ContentTypeReader<TRead>
    {
        protected override TRead Read(ContentReader input, TRead existingInstance)
        {
            // calc the number of characters that will be read
            int count = (int)(input.BaseStream.Length - input.BaseStream.Position);

            // create a string reader to store the data that will be read
            StringBuilder sb = new StringBuilder(count, count);

            // read "count" number of characters from the input object and append the data
            // to the StringBuilder varible
            sb.Append(input.ReadChars(count));

            // create a new XmlDocument object
            XmlDocument Doc = new XmlDocument();

            // try loading the data
            try
            {
                // attempt to load the data stored in the sb object into the Doc 
                Doc.LoadXml(sb.ToString());
            }
            catch (Exception ex)
            {
                // throw a InvalidContentException exception reporting the error
                throw new XmlException(Resources.BadFileData, ex);
            }

            sb = null;
            // return the reference the Doc varible
            return Doc;
        }
    }
}
